Package com.google.android.exoplayer2.upstream.cache

## Class CacheDataSource

- java.lang.Object
- - com.google.android.exoplayer2.upstream.cache.CacheDataSource

- All Implemented Interfaces:
    `DataReader`, `DataSource`

      public final class CacheDataSource
      extends Object
      implements DataSource

  A `DataSource` that reads and writes a `Cache`. Requests are fulfilled from the cache when possible. When data is not cached it is requested from an upstream `DataSource` and written into the cache.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static interface` | `CacheDataSource.CacheIgnoredReason` | Reasons the cache may be ignored.
    `static interface` | `CacheDataSource.EventListener` | Listener of `CacheDataSource` events.
    `static class` | `CacheDataSource.Factory` | `DataSource.Factory` for `CacheDataSource` instances.
    `static interface` | `CacheDataSource.Flags` | Flags controlling the CacheDataSource's behavior.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static int` | `CACHE_IGNORED_REASON_ERROR` | Cache ignored due to a cache related error.
    `static int` | `CACHE_IGNORED_REASON_UNSET_LENGTH` | Cache ignored due to a request with an unset length.
    `static int` | `FLAG_BLOCK_ON_CACHE` | A flag indicating whether we will block reads if the cache key is locked.
    `static int` | `FLAG_IGNORE_CACHE_FOR_UNSET_LENGTH_REQUESTS` | A flag indicating that the cache should be bypassed for requests whose lengths are unset.
    `static int` | `FLAG_IGNORE_CACHE_ON_ERROR` | A flag indicating whether the cache is bypassed following any cache related error.

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `CacheDataSource​(Cache cache, DataSource upstreamDataSource)` | Constructs an instance with default `DataSource` and `DataSink` instances for reading and writing the cache.
    `CacheDataSource​(Cache cache, DataSource upstreamDataSource, int flags)` | Constructs an instance with default `DataSource` and `DataSink` instances for reading and writing the cache.
    `CacheDataSource​(Cache cache, DataSource upstreamDataSource, DataSource cacheReadDataSource, DataSink cacheWriteDataSink, int flags, CacheDataSource.EventListener eventListener)` | Constructs an instance with arbitrary `DataSource` and `DataSink` instances for reading and writing the cache.
    `CacheDataSource​(Cache cache, DataSource upstreamDataSource, DataSource cacheReadDataSource, DataSink cacheWriteDataSink, int flags, CacheDataSource.EventListener eventListener, CacheKeyFactory cacheKeyFactory)` | Constructs an instance with arbitrary `DataSource` and `DataSink` instances for reading and writing the cache.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addTransferListener​(TransferListener transferListener)` | Adds a `TransferListener` to listen to data transfers.
    `void` | `close()` | Closes the source.
    `Cache` | `getCache()` | Returns the `Cache` used by this instance.
    `CacheKeyFactory` | `getCacheKeyFactory()` | Returns the `CacheKeyFactory` used by this instance.
    `Map<String,​List<String>>` | `getResponseHeaders()` | When the source is open, returns the response headers associated with the last `DataSource.open(com.google.android.exoplayer2.upstream.DataSpec)` call.
    `Uri` | `getUri()` | When the source is open, returns the `Uri` from which data is being read.
    `long` | `open​(DataSpec dataSpec)` | Opens the source to read the specified data.
    `int` | `read​(byte[] buffer, int offset, int readLength)` | Reads up to `length` bytes of data from the input.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### FLAG_BLOCK_ON_CACHE

          public static final int FLAG_BLOCK_ON_CACHE

      A flag indicating whether we will block reads if the cache key is locked. If unset then data is read from upstream if the cache key is locked, regardless of whether the data is cached.
      See Also:
        Constant Field Values

    - #### FLAG_IGNORE_CACHE_ON_ERROR

          public static final int FLAG_IGNORE_CACHE_ON_ERROR

      A flag indicating whether the cache is bypassed following any cache related error. If set then cache related exceptions may be thrown for one cycle of open, read and close calls. Subsequent cycles of these calls will then bypass the cache.
      See Also:
        Constant Field Values

    - #### FLAG_IGNORE_CACHE_FOR_UNSET_LENGTH_REQUESTS

          public static final int FLAG_IGNORE_CACHE_FOR_UNSET_LENGTH_REQUESTS

      A flag indicating that the cache should be bypassed for requests whose lengths are unset. This flag is provided for legacy reasons only.
      See Also:
        Constant Field Values

    - #### CACHE_IGNORED_REASON_ERROR

          public static final int CACHE_IGNORED_REASON_ERROR

      Cache ignored due to a cache related error.
      See Also:
        Constant Field Values

    - #### CACHE_IGNORED_REASON_UNSET_LENGTH

          public static final int CACHE_IGNORED_REASON_UNSET_LENGTH

      Cache ignored due to a request with an unset length.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### CacheDataSource

          public CacheDataSource​(Cache cache,
                                 @Nullable
                                 DataSource upstreamDataSource)

      Constructs an instance with default `DataSource` and `DataSink` instances for reading and writing the cache.
      Parameters:
        `cache` - The cache.
        `upstreamDataSource` - A `DataSource` for reading data not in the cache. If null, reading will fail if a cache miss occurs.

    - #### CacheDataSource

          public CacheDataSource​(Cache cache,
                                 @Nullable
                                 DataSource upstreamDataSource,
                                 @Flags
                                 int flags)

      Constructs an instance with default `DataSource` and `DataSink` instances for reading and writing the cache.
      Parameters:
        `cache` - The cache.
        `upstreamDataSource` - A `DataSource` for reading data not in the cache. If null, reading will fail if a cache miss occurs.
        `flags` - A combination of `FLAG_BLOCK_ON_CACHE`, `FLAG_IGNORE_CACHE_ON_ERROR` and `FLAG_IGNORE_CACHE_FOR_UNSET_LENGTH_REQUESTS`, or 0.

    - #### CacheDataSource

          public CacheDataSource​(Cache cache,
                                 @Nullable
                                 DataSource upstreamDataSource,
                                 DataSource cacheReadDataSource,
                                 @Nullable
                                 DataSink cacheWriteDataSink,
                                 @Flags
                                 int flags,
                                 @Nullable
                                 CacheDataSource.EventListener eventListener)

      Constructs an instance with arbitrary `DataSource` and `DataSink` instances for reading and writing the cache. One use of this constructor is to allow data to be transformed before it is written to disk.
      Parameters:
        `cache` - The cache.
        `upstreamDataSource` - A `DataSource` for reading data not in the cache. If null, reading will fail if a cache miss occurs.
        `cacheReadDataSource` - A `DataSource` for reading data from the cache.
        `cacheWriteDataSink` - A `DataSink` for writing data to the cache. If null, cache is accessed read-only.
        `flags` - A combination of `FLAG_BLOCK_ON_CACHE`, `FLAG_IGNORE_CACHE_ON_ERROR` and `FLAG_IGNORE_CACHE_FOR_UNSET_LENGTH_REQUESTS`, or 0.
        `eventListener` - An optional `CacheDataSource.EventListener` to receive events.

    - #### CacheDataSource

          public CacheDataSource​(Cache cache,
                                 @Nullable
                                 DataSource upstreamDataSource,
                                 DataSource cacheReadDataSource,
                                 @Nullable
                                 DataSink cacheWriteDataSink,
                                 @Flags
                                 int flags,
                                 @Nullable
                                 CacheDataSource.EventListener eventListener,
                                 @Nullable
                                 CacheKeyFactory cacheKeyFactory)

      Constructs an instance with arbitrary `DataSource` and `DataSink` instances for reading and writing the cache. One use of this constructor is to allow data to be transformed before it is written to disk.
      Parameters:
        `cache` - The cache.
        `upstreamDataSource` - A `DataSource` for reading data not in the cache. If null, reading will fail if a cache miss occurs.
        `cacheReadDataSource` - A `DataSource` for reading data from the cache.
        `cacheWriteDataSink` - A `DataSink` for writing data to the cache. If null, cache is accessed read-only.
        `flags` - A combination of `FLAG_BLOCK_ON_CACHE`, `FLAG_IGNORE_CACHE_ON_ERROR` and `FLAG_IGNORE_CACHE_FOR_UNSET_LENGTH_REQUESTS`, or 0.
        `eventListener` - An optional `CacheDataSource.EventListener` to receive events.
        `cacheKeyFactory` - An optional factory for cache keys.

  - ### Method Detail

    - #### getCache

          public Cache getCache()

      Returns the `Cache` used by this instance.

    - #### getCacheKeyFactory

          public CacheKeyFactory getCacheKeyFactory()

      Returns the `CacheKeyFactory` used by this instance.

    - #### addTransferListener

          public void addTransferListener​(TransferListener transferListener)

      Description copied from interface: `DataSource`
      Adds a `TransferListener` to listen to data transfers. This method is not thread-safe.
      Specified by:
        `addTransferListener` in interface `DataSource`
      Parameters:
        `transferListener` - A `TransferListener`.

    - #### open

          public long open​(DataSpec dataSpec)
                    throws IOException

      Description copied from interface: `DataSource`
      Opens the source to read the specified data. If an `IOException` is thrown, callers must still call `DataSource.close()` to ensure that any partial effects of the invocation are cleaned up.

      The following edge case behaviors apply:

      - If the `requested position` is within the resource, but the `requested length` extends beyond the end of the resource, then `DataSource.open(com.google.android.exoplayer2.upstream.DataSpec)` will succeed and data from the requested position to the end of the resource will be made available through `DataReader.read(byte[], int, int)`.
      - If the `requested position` is equal to the length of the resource, then `DataSource.open(com.google.android.exoplayer2.upstream.DataSpec)` will succeed, and `DataReader.read(byte[], int, int)` will immediately return `C.RESULT_END_OF_INPUT`.
      - If the `requested position` is greater than the length of the resource, then `DataSource.open(com.google.android.exoplayer2.upstream.DataSpec)` will throw an `IOException` for which `DataSourceException.isCausedByPositionOutOfRange(java.io.IOException)` will be `true`.
      Specified by:
        `open` in interface `DataSource`
      Parameters:
        `dataSpec` - Defines the data to be read.
      Returns:
        The number of bytes that can be read from the opened source. For unbounded requests (i.e., requests where `DataSpec.length` equals `C.LENGTH_UNSET`) this value is the resolved length of the request, or `C.LENGTH_UNSET` if the length is still unresolved. For all other requests, the value returned will be equal to the request's `DataSpec.length`.
      Throws:
        `IOException` - If an error occurs opening the source. `DataSourceException` can be thrown or used as a cause of the thrown exception to specify the reason of the error.

    - #### read

          public int read​(byte[] buffer,
                          int offset,
                          int readLength)
                   throws IOException

      Description copied from interface: `DataReader`
      Reads up to `length` bytes of data from the input.

      If `readLength` is zero then 0 is returned. Otherwise, if no data is available because the end of the opened range has been reached, then `C.RESULT_END_OF_INPUT` is returned. Otherwise, the call will block until at least one byte of data has been read and the number of bytes read is returned.

      Specified by:
        `read` in interface `DataReader`
      Parameters:
        `buffer` - A target array into which data should be written.
        `offset` - The offset into the target array at which to write.
        `readLength` - The maximum number of bytes to read from the input.
      Returns:
        The number of bytes read, or `C.RESULT_END_OF_INPUT` if the input has ended. This may be less than `length` because the end of the input (or available data) was reached, the method was interrupted, or the operation was aborted early for another reason.
      Throws:
        `IOException` - If an error occurs reading from the input.

    - #### getUri

          @Nullable
          public Uri getUri()

      Description copied from interface: `DataSource`
      When the source is open, returns the `Uri` from which data is being read. The returned `Uri` will be identical to the one passed `DataSource.open(DataSpec)` in the `DataSpec` unless redirection has occurred. If redirection has occurred, the `Uri` after redirection is returned.
      Specified by:
        `getUri` in interface `DataSource`
      Returns:
        The `Uri` from which data is being read, or null if the source is not open.

    - #### getResponseHeaders

          public Map<String,​List<String>> getResponseHeaders()

      Description copied from interface: `DataSource`
      When the source is open, returns the response headers associated with the last `DataSource.open(com.google.android.exoplayer2.upstream.DataSpec)` call. Otherwise, returns an empty map.

      Key look-up in the returned map is case-insensitive.

      Specified by:
        `getResponseHeaders` in interface `DataSource`

    - #### close

          public void close()
                     throws IOException

      Description copied from interface: `DataSource`
      Closes the source. This method must be called even if the corresponding call to `DataSource.open(DataSpec)` threw an `IOException`.
      Specified by:
        `close` in interface `DataSource`
      Throws:
        `IOException` - If an error occurs closing the source.